
//package AddGeoJava;
//package mdWebServiceAddress;
//package address;
//package AddressCheck;

import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RemoteException;
import javax.xml.rpc.ServiceException;
import java.util.*;

import mdWebServiceAddress.*;
import MelissaDataAddressCheckService.*;
//import AddressCheck.mdWebServiceAddress.RequestArray;

public class mdAddressCheck
{
    private final String SERVICE_LOC =
        "https://addresscheck.melissadata.net/v2/SOAP/Service.svc";

    //private static final String SERVICE_LOC =
    //        "http://addresscheck.melissadata.com/v2/SOAP/Service.svc";


	private String CUSTOMER_ID, record, company, urbanization, address1,
	address2, city, state, zip, plus4, suite, country, lastname;

	RequestArray request;
	ResponseArray response;
	IService mdWebService;
	RequestArrayRecord reqArray[];
	ResponseArrayRecord resArray[];

	public void initialize()
	{
		//Create Request Array, Response Array and mdWebServices
        request = new RequestArray();
        response = new ResponseArray();
        mdWebService = null;

		//Create an Array of Requests and Responses with a maximum of 100 records
        reqArray = new RequestArrayRecord[100];

		//Set the customer ID
        request.setCustomerID(CUSTOMER_ID);
        request.setTransmissionReference("Testing DQWS V2 SOAP using Java Sample Code");
	}
    public void doAddressCheck()
	{
        try
        {

            ServiceLocator locator = new ServiceLocator();

			//Insert thhe request Array to the Request
        	request.setRecord(reqArray);

            try
            {
                //Set SOAP Web Service URL
                mdWebService =  locator.getBasicHttpBinding_IService((new URL(SERVICE_LOC)));

            }
            catch (ServiceException e)
            {
                System.out.println("Exception " + e.toString());
            }
            catch (MalformedURLException e)
            {
                System.out.println("Exception " + e.toString());
            }

            try
            {
                //Do AddressCheck
                response = mdWebService.doAddressCheck(request);
            }
            catch (RemoteException e)
            {
                System.out.println("Exception" + e.toString());
            }


            //Output results onto the console
			resArray = new ResponseArrayRecord[100];

            resArray = response.getRecord();

			System.out.println("");
            System.out.println("Address Check Response");
            System.out.println("----------------------------------------");

			// If this method returns tru, that means, it printed an error, therefore, stop the process.
			if(printGlobalResults(response.getResults()))
			{
				return;
			}

			//for(int i = 0; i < Integer.parseInt(response.getTotalRecords()); i++)
			for(int i = 0; i < resArray.length; i++)
			{
				System.out.println("RECORD NUMBER: " + resArray[i].getRecordID());
	            System.out.println("Result Codes: " + resArray[i].getResults());

				//Print out results description
	            printResultDesc(resArray[i].getResults());

	            //Continue outputing results onto the console
	            System.out.println("Address: " + resArray[i].getAddress().getAddress1());
	            System.out.println("City: " + resArray[i].getAddress().getCity().getName());
	            System.out.println("State: " + resArray[i].getAddress().getState().getAbbreviation());
	            System.out.println("Zip: " + resArray[i].getAddress().getZip());
	            System.out.println("Plus4: " + resArray[i].getAddress().getPlus4());
	            System.out.println("Urbanization: " + resArray[i].getAddress().getUrbanization().getName());
	            System.out.println("DPC: " + resArray[i].getAddress().getDeliveryPointCode());
	            System.out.println("AddressKey: " + resArray[i].getAddress().getAddressKey());
				System.out.println("");
            }

        }
        catch (Exception e)
        {
            System.out.println("Exception " + e.toString());
        }

    } // Method Main

	public void insertRecord(int RecNum)
	{
        //Create Request Here
        RequestArrayRecord reqRecord = new RequestArrayRecord();

        reqRecord.setRecordID(record);
        reqRecord.setCompany(company);
        reqRecord.setUrbanization(urbanization);
        reqRecord.setAddressLine1(address1);
        reqRecord.setAddressLine2(address2);
        reqRecord.setCity(city);
        reqRecord.setState(state);
        reqRecord.setZip(zip);
        reqRecord.setPlus4(plus4);
        reqRecord.setSuite(suite);
        reqRecord.setCountry(country);
		  reqRecord.setLastName(lastname);

        //Output the request onto the console
        System.out.println("");
        System.out.println("AddressCheck Request Array Input");
        System.out.println("----------------------------------------");
        System.out.println("Company: " + reqRecord.getCompany());
        System.out.println("Urbanization: " + reqRecord.getUrbanization());
        System.out.println("AddressLine1: " + reqRecord.getAddressLine1());
        System.out.println("AddressLine2: " + reqRecord.getAddressLine2());
        System.out.println("City: " + reqRecord.getCity());
        System.out.println("State: " + reqRecord.getState());
        System.out.println("Zip: " + reqRecord.getZip());
        System.out.println("Plus4: " + reqRecord.getPlus4());
        System.out.println("Suite: " + reqRecord.getSuite());
        System.out.println("Country: " + reqRecord.getCountry());

        //Add Request to the Request Array
        reqArray[RecNum] = reqRecord;

	}

	public void clearProperties()
	{
		company = "";
		urbanization = "";
		address1 = "";
		address2 = "";
		city = "";
		state = "";
		zip = "";
		plus4 = "";
		suite = "";
		country = "";
		lastname = "";
	}

	public void setCustomerID(String ID)
	{
		CUSTOMER_ID = ID;
	}
	public void setRecord(String rec)
	{
		record = rec;
	}

	public void setCompany(String com)
	{
		company = com;
	}

	public void setUrbanization(String urb)
	{
		urbanization = urb;
	}

	public void setAddress1(String add1)
	{
		address1 = add1;
	}

	public void setAddress2(String add2)
	{
		address2 = add2;
	}

	public void setCity(String cty)
	{
		city = cty;
	}

	public void setState(String st)
	{
		state = st;
	}

	public void setZip(String zp)
	{
		zip = zp;
	}

	public void setPlus4(String p4)
	{
		plus4 = p4;
	}

	public void setSuite(String ste)
	{
		suite = ste;
	}

	public void setCountry(String ctry)
	{
		country = ctry;
	}
	public void setLastName(String last)
	{
		lastname = last;
	}


	//***********************************************
	// Method to tokenize global result code list
	//  and output the equivalent result
	//  description to console
	//***********************************************
	private boolean printGlobalResults(String resultCode)
	{
		//Tokenize results and individually output their description
        StringBuffer sb = new StringBuffer(100);
        StringTokenizer scanner;
        scanner = new StringTokenizer(resultCode, ",");

		System.out.println("Global Results: ");

		if(!resultCode.equals(" "))
		{
	        while (scanner.hasMoreTokens())
	        {
	            String resultCodeElement = scanner.nextToken();

				//Verified Section
	            if (resultCodeElement.equals("SE01"))
	            {
	                System.out.println("\t SE01: " + "Web Servoce Internal Error");
	            }
				if (resultCodeElement.equals("GE01"))
	            {
	                System.out.println("\t GE01: " + "Empty XML Request Structure");
	            }
				if (resultCodeElement.equals("GE02"))
	            {
	                System.out.println("\t GE02: " + "Empty XML Request Record Structure");
	            }
				if (resultCodeElement.equals("GE03"))
	            {
	                System.out.println("\t GE03: " + "Inserted Records Exceed Maximum Amount");
	            }
				if (resultCodeElement.equals("GE04"))
	            {
	                System.out.println("\t GE04: " + "Customer ID Empty");
	            }
				if (resultCodeElement.equals("GE05"))
	            {
	                System.out.println("\t GE05: " + "Customer ID Not Valid");
	            }
				if (resultCodeElement.equals("GE06"))
	            {
	                System.out.println("\t GE06: " + "Customer ID Disabled");
	            }
				if (resultCodeElement.equals("GE07"))
	            {
	                System.out.println("\t GE07: " + "XML Request Invalid");
	            }
				return true;
	        }
		}
		return false;
	}


	//***********************************************
	// Method to tokenize result code list
	//  and output the equivalent result
	//  description to console
	//***********************************************
	public void printResultDesc(String resultCode)
	{
		//Tokenize results and individually output their description
        StringBuffer sb = new StringBuffer(100);
        StringTokenizer scanner;
        scanner = new StringTokenizer(resultCode, ",");

		System.out.println("Result Description List: ");

        while (scanner.hasMoreTokens())
        {
            String resultCodeElement = scanner.nextToken();

			//Verified Section
            if (resultCodeElement.equals("AS01"))
            {
                System.out.println("\t AS01: " + "Address Matched to a postal patabase");
            }
			if (resultCodeElement.equals("AS02"))
            {
                System.out.println("\t AS02: " + " Address matched to a non-postal databasee");
            }
			if (resultCodeElement.equals("AS09"))
            {
                System.out.println("\t AS02: " + " Foreign Postal Code Detected");
            }
			if (resultCodeElement.equals("AS10"))
            {
                System.out.println("\t AS10: " + "Address Matched to CMRA");
            }
			if (resultCodeElement.equals("AS11"))
            {
                System.out.println("\t AS11: " + "Address Vacant");
            }
			if (resultCodeElement.equals("AS12"))
            {
                System.out.println("\t AS12: " + "Address Matched to DPV");
            }
			if (resultCodeElement.equals("AS13"))
            {
                System.out.println("\t AS13: " + "Address updated by LACS");
            }
			if (resultCodeElement.equals("AS14"))
	         {
	             System.out.println("\t AS14: " + "Address updated by Suite Link");
	         }
			if (resultCodeElement.equals("AS15"))
	         {
	             System.out.println("\t AS15: " + "Address updated by Suite Finder");
	         }

			//Errors Section
			if (resultCodeElement.equals("AE01"))
            {
                System.out.println("\t AE01: " + "Zip Code Error");
            }
			if (resultCodeElement.equals("AE02"))
            {
                System.out.println("\t AE02: " + "Unknown Street");
            }
			if (resultCodeElement.equals("AE03"))
            {
                System.out.println("\t AE03: " + "Component Error");
            }
			if (resultCodeElement.equals("AE04"))
            {
                System.out.println("\t AE04: " + "Non-Deliverable Address");
            }
			if (resultCodeElement.equals("AE05"))
            {
                System.out.println("\t AE05: " + "Address matched to multiple records");
            }
			if (resultCodeElement.equals("AE06"))
            {
                System.out.println("\t AE06: " + "Address Matched to Early Warning System");
            }
			if (resultCodeElement.equals("AE07"))
            {
                System.out.println("\t AE07: " + "Empty Address Input");
            }
			if (resultCodeElement.equals("AE08"))
            {
                System.out.println("\t AE08: " + "Suite Range Error");
            }
			if (resultCodeElement.equals("AE09"))
            {
                System.out.println("\t AE09: " + "Suite Range Missing");
            }
			if (resultCodeElement.equals("AE10"))
            {
                System.out.println("\t AE10: " + "Primary Rnage Error");
            }
			if (resultCodeElement.equals("AE11"))
            {
                System.out.println("\t AE11: " + "Primary Range Missing");
            }
			if (resultCodeElement.equals("AE12"))
            {
                System.out.println("\t AE12: " + "Box Number Error from PO Box or RR");
            }
			if (resultCodeElement.equals("AE13"))
            {
                System.out.println("\t AE13: " + "PO Box Number Missing from PO Box or RR");
            }
			if (resultCodeElement.equals("AE14"))
            {
                System.out.println("\t AE14: " + "Input Address Matched to CMRA but secondary number not present");
            }
        }
	}


} //Class mdAddressCheckSample


