
//package AddGeoJava;
//package mdWebServiceAddress;
//package address;
//package AddressCheck;

import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RemoteException;
import javax.xml.rpc.ServiceException;
import java.util.*;

import mdWebServiceGeoCode.*;
import MelissaDataGeoCodeService.*;
//import AddressCheck.mdWebServiceAddress.RequestArray;

public class mdGeoCode
{
    private String SERVICE_LOC =
        "https://geocoder.melissadata.net/v2/SOAP/Service.svc";

    //private static final String SERVICE_LOC =
    //        "http://addresscheck.melissadata.com/v2/SOAP/Service.svc";


	private String CUSTOMER_ID, record, addressKey;

	RequestArray request;
	ResponseArray response;
	IService mdWebService;
	RequestArrayRecord reqArray[];

	public void initialize()
	{
		//Create Request Array, Response Array and mdWebServices
        request = new RequestArray();
        response = new ResponseArray();
        mdWebService = null;

		//Create an Array of Requests and Responses with a maximum of 100 records
        reqArray = new RequestArrayRecord[100];

		//Set the customer ID
        request.setCustomerID(CUSTOMER_ID);
        request.setTransmissionReference("Testing DQWS V2 SOAP using Java Sample Code");
	}
    public void doGeoCode()
	{
        try
        {

            ServiceLocator locator = new ServiceLocator();

			//Insert thhe request Array to the Request
        	request.setRecord(reqArray);

            try
            {
                //Set SOAP Web Service URL
                mdWebService =  locator.getBasicHttpBinding_IService((new URL(SERVICE_LOC)));

            }
            catch (ServiceException e)
            {
                System.out.println("Exception " + e.toString());
            }
            catch (MalformedURLException e)
            {
                System.out.println("Exception " + e.toString());
            }

            try
            {
                //Do AddressCheck
                response = mdWebService.doGeoCode(request);
            }
            catch (RemoteException e)
            {
                System.out.println("Exception" + e.toString());
            }


            //Output results onto the console
			ResponseArrayRecord resArray[] = new ResponseArrayRecord[100];

            resArray = response.getRecord();

			System.out.println("");
            System.out.println("GeoCode Response");
            System.out.println("----------------------------------------");

			// If this method returns tru, that means, it printed an error, therefore, stop the process.
			if(printGlobalResults(response.getResults()))
			{
				return;
			}

			//for(int i = 0; i < Integer.parseInt(response.getTotalRecords()); i++)
			for(int i = 0; i < resArray.length; i++)
			{
	            System.out.println("Result Codes: " + resArray[i].getResults());

				//Print out results description
	            printResultDesc(resArray[i].getResults());

	            //Continue outputing results onto the console
	            System.out.println("County Name: " + resArray[i].getAddress().getCounty().getName());
	            System.out.println("County Fips: " + resArray[i].getAddress().getCounty().getFips());
	            System.out.println("Latitude: " + resArray[i].getAddress().getLatitude());
	            System.out.println("Longitude: " + resArray[i].getAddress().getLongitude());
	            System.out.println("Place Name: " + resArray[i].getAddress().getPlace().getName());
	            System.out.println("Place Code: " + resArray[i].getAddress().getPlace().getCode());
	            System.out.println("Time Zone Name: " + resArray[i].getAddress().getTimeZone().getName());
	            System.out.println("Time Zone Code: " + resArray[i].getAddress().getTimeZone().getCode());
				System.out.println("CBSA Titel: " + resArray[i].getAddress().getCBSA().getTitle());
				System.out.println("CBSA Code: " + resArray[i].getAddress().getCBSA().getCode());
				System.out.println("CBSA Level: " + resArray[i].getAddress().getCBSA().getLevel());
				System.out.println("");
            }
        }
        catch (Exception e)
        {
            System.out.println("Exception " + e.toString());
        }

    } // Method Main

	public void insertRecord(int RecNum)
	{


        //Create Request Here
        RequestArrayRecord reqRecord = new RequestArrayRecord();

        reqRecord.setRecordID(record);
        reqRecord.setAddressKey(addressKey);

        //Output the request onto the console
        System.out.println("");
        System.out.println("GeoCode Request Array Inputs");
        System.out.println("----------------------------------------");
        System.out.println("Address Key: " + reqRecord.getAddressKey());


        //Add Request to the Request Array
        reqArray[RecNum] = reqRecord;

	}

	public void clearProperties()
	{
		record = "";
		addressKey = "";
	}

	public void setCustomerID(String ID)
	{
		CUSTOMER_ID = ID;
	}
	public void setRecord(String rec)
	{
		record = rec;
	}

	public void setAddressKey(String key)
	{
		addressKey = key;
	}



	//***********************************************
	// Method to tokenize result code list
	//  and output the equivalent result
	//  description to console
	//***********************************************
	private void printResultDesc(String resultCode)
	{
		//Tokenize results and individually output their description
        StringBuffer sb = new StringBuffer(100);
        StringTokenizer scanner;
		scanner = null;
        scanner = new StringTokenizer(resultCode, ",");

		System.out.println("Result Description List: ");

        while (scanner.hasMoreTokens())
        {
            String resultCodeElement = scanner.nextToken();

			//Verified Section
            if (resultCodeElement.equals("GS01"))
            {
                System.out.println("\t GS01: " + "Geocoded to Zip+4 or the full 6-digit Postal Code Centroid");
            }
			if (resultCodeElement.equals("GS02"))
            {
                System.out.println("\t GS02: " + "Geocoded to Zip+2 Centroid");
            }
			if (resultCodeElement.equals("GS03"))
            {
                System.out.println("\t GS03: " + "Geocoded to 5 digit (U.S.) or 3 digit (Canada) zip code Centroid");
            }
			if (resultCodeElement.equals("GS05"))
            {
                System.out.println("\t GS05: " + "Geocoded to Rooftop level");
            }
			if (resultCodeElement.equals("GS06"))
            {
                System.out.println("\t GS06: " + "Geocoded to Interpolated Rooftop level");
            }
			//Errors Section
			if (resultCodeElement.equals("GE01"))
            {
                System.out.println("\t GE01: " + "Zip Code Error");
            }
			if (resultCodeElement.equals("DE"))
            {
                System.out.println("\t DE: " + "Error in Data Field");
            }
        }
	} //Method printResultDesc


	//***********************************************
	// Method to tokenize global result code list
	//  and output the equivalent result
	//  description to console
	//***********************************************
	private boolean printGlobalResults(String resultCode)
	{
		//Tokenize results and individually output their description
        StringBuffer sb = new StringBuffer(100);
        StringTokenizer scanner;
        scanner = new StringTokenizer(resultCode, ",");

		System.out.println("Global Results: ");

		if(!resultCode.equals(" "))
		{
	        while (scanner.hasMoreTokens())
	        {
	            String resultCodeElement = scanner.nextToken();

				//Verified Section
	            if (resultCodeElement.equals("SE01"))
	            {
	                System.out.println("\t SE01: " + "Web Servoce Internal Error");
	            }
				if (resultCodeElement.equals("GE01"))
	            {
	                System.out.println("\t GE01: " + "Empty XML Request Structure");
	            }
				if (resultCodeElement.equals("GE02"))
	            {
	                System.out.println("\t GE02: " + "Empty XML Request Record Structure");
	            }
				if (resultCodeElement.equals("GE03"))
	            {
	                System.out.println("\t GE03: " + "Inserted Records Exceed Maximum Amount");
	            }
				if (resultCodeElement.equals("GE04"))
	            {
	                System.out.println("\t GE04: " + "Customer ID Empty");
	            }
				if (resultCodeElement.equals("GE05"))
	            {
	                System.out.println("\t GE05: " + "Customer ID Not Valid");
	            }
				if (resultCodeElement.equals("GE06"))
	            {
	                System.out.println("\t GE06: " + "Customer ID Disabled");
	            }
				if (resultCodeElement.equals("GE07"))
	            {
	                System.out.println("\t GE07: " + "XML Request Invalid");
	            }
				return true;
			}
        }
		return false;
	}





} //Class mdAddressCheckSample


